TestJose/Models/CommentProject.cs
using System;
using System.ComponentModel.DataAnnotations;

namespace TestJose.DataAccess
{
    public class CommentProject
    {
        public int ID { get; set; }

        [Display(Name = "Project")]
        public int ProjectID { get; set; }

        public virtual Project Project { get; set; }

        [DataType(DataType.Date)]
        [DisplayFormat(ApplyFormatInEditMode = true, DataFormatString = "{0:yyyy-MM-dd}")]
        public DateTime Date { get; set; }

        [Required]
        public string Comment { get; set; }

        [Display(Name = "User")]
        public string UserID { get; set; }

        public virtual ApplicationUser User { get; set; }

        [Display(Name = "Section")]
        public int SectionID { get; set; }

        public virtual Section Section{ get; set; }
    }
}

TestJose/Controllers/CommentProjectsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using TestJose.DataAccess;
using X.PagedList;

namespace TestJose.Controllers
{
    [Authorize(Roles = "Admin,Basic")]
    public class CommentProjectsController : Controller
    {
        private readonly TestJoseDbContext _context;

        public CommentProjectsController(TestJoseDbContext context)
        {
            _context = context;
        }

        // GET: CommentProjects
        public async Task<IActionResult> Index(int? projectId, int? page)
        {
            ViewData["ProjectID"] = projectId;
            var comments = await _context.Comment
                .Include(c => c.Project)
                .Include(c => c.User)
                .Where(x => x.ProjectID == projectId)
                .OrderByDescending(x => x.Date)
                .ToListAsync();

            return View(comments.ToPagedList(page ?? 1, 10));
        }

        public async Task<IActionResult> MyComments(int? page)
        {
            var userId = User.FindFirstValue(ClaimTypes.NameIdentifier);
            var comments = await _context.Comment
                .Include(c => c.Project)
                .Include(c => c.User)
                .Where(x => x.UserID == userId)
                .OrderByDescending(x => x.Date)
                .ToListAsync();

            return View(comments.ToPagedList(page ?? 1, 3));
        }

        // GET: CommentProjects/Create
        public async Task<IActionResult> Create(int projectId)
        {
            await LoadViewData(projectId, null);

            return View();
        }

        // POST: CommentProjects/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("ID,ProjectID,Date,Comment,SectionID")] CommentProject commentProject)
        {
            if (ModelState.IsValid)
            {
                var user = User.FindFirstValue(ClaimTypes.NameIdentifier);
                commentProject.UserID = user;

                _context.Add(commentProject);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index), new { projectId = commentProject.ProjectID });
            }
            await LoadViewData(commentProject.ProjectID, commentProject.SectionID);

            return View(commentProject);
        }

        // GET: CommentProjects/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var commentProject = await _context.Comment.FindAsync(id);
            if (commentProject == null)
            {
                return NotFound();
            }
            await LoadViewData(commentProject.ProjectID, commentProject.SectionID);

            return View(commentProject);
        }

        // POST: CommentProjects/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("ID,ProjectID,Date,Comment,SectionID,UserID")] CommentProject commentProject)
        {
            if (id != commentProject.ID)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(commentProject);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!CommentProjectExists(commentProject.ID))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index), new { projectId = commentProject.ProjectID });
            }
            await LoadViewData(commentProject.ProjectID, commentProject.SectionID);

            return View(commentProject);
        }

        private async Task LoadViewData(int projectId, int? sectionId)
        {
            ViewData["ProjectID"] = projectId;
            var projectSections = await _context.ProjectSection.Where(x => x.ProjectId == projectId).ToListAsync();
            ViewData["SectionID"] = new SelectList(projectSections, "SectionId", "Section.Name", sectionId);
        }

        // GET: CommentProjects/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var commentProject = await _context.Comment
                .Include(c => c.Project)
                .FirstOrDefaultAsync(m => m.ID == id);
            if (commentProject == null)
            {
                return NotFound();
            }

            return View(commentProject);
        }

        // POST: CommentProjects/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var commentProject = await _context.Comment.FindAsync(id);
            _context.Comment.Remove(commentProject);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index), new { projectId = commentProject.ProjectID});
        }

        // GET: Projects/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var comment = await _context.Comment
                .Include(p => p.Section)
                .Include(p => p.User)
                .Include(p => p.Project)
                .FirstOrDefaultAsync(m => m.ID == id);
            if (comment == null)
            {
                return NotFound();
            }

            return View(comment);
        }

        private bool CommentProjectExists(int id)
        {
            return _context.Comment.Any(e => e.ID == id);
        }
    }
}

TestJose/Controllers/ProjectsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using TestJose.DataAccess;
using X.PagedList;

namespace TestJose.Controllers
{
    [Authorize(Roles = "Admin,Basic")]
    public class ProjectsController : Controller
    {
        private readonly TestJoseDbContext _context;

        public ProjectsController(TestJoseDbContext context)
        {
            _context = context;
        }

        // GET: Projects
        public async Task<IActionResult> Index(int? page, int? filterType, string filterName, string filterSite, int? filterYear)
        {
            var projects = _context.Project.Include(p => p.TypeProject).Include(x => x.ProjectSections).AsQueryable();
            ViewData["TypeProjects"] = new SelectList(_context.TypeProject.Where(x => x.Active), "ID", "Name");
            ViewData["Years"] = new SelectList(Enumerable.Range(DateTime.Now.AddYears(-2).Year, 10).Select(x => new { ID = x, Name = x }), "ID", "Name");

            if (filterType.HasValue)
            {
                projects = projects.Where(x => x.TypeProjectID == filterType);
            }
            if(!string.IsNullOrEmpty(filterName))
            {
                projects = projects.Where(x => x.Name.Contains(filterName.Trim()));
            }
            //if (!string.IsNullOrEmpty(filterSite))
            //{
            //    projects = projects.Where(x => x.Site.Contains(filterSite.Trim()));
            //}
            if (filterYear.HasValue)
            {
                projects = projects.Where(x => x.Year.Equals(filterYear));
            }

            var list = await projects.ToListAsync();

            return View(list.ToPagedList(page ?? 1, 10));
        }

        // GET: Projects/Create
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            LoadViewData(null, new List<int>(), new List<int>());

            return View();
        }


        // POST: Projects/Create
        [Authorize(Roles = "Admin")]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("ID,TypeProjectID,Name,SiteIds,Year,SectionIds")] Project project)
        {
            if (ModelState.IsValid)
            {
                if(project.SectionIds == null)
                {
                    ModelState.AddModelError("ProjectSections", "The Sections is required");
                    LoadViewData(project, project.SectionIds, project.SiteIds);
                    return View();
                }

                if (project.SiteIds == null)
                {
                    ModelState.AddModelError("ProjectSite", "The Sites is required");
                    LoadViewData(project, project.SectionIds, project.SiteIds);
                    return View();
                }
                project.ProjectSections = project.SectionIds.Select(x => new ProjectSection { SectionId = x }).ToList();
                project.ProjectSites = project.SiteIds.Select(x => new ProjectSite { SiteId = x }).ToList();
                _context.Add(project);

                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            LoadViewData(project, project.SectionIds, project.SiteIds);

            return View(project);
        }

        // GET: Projects/Edit/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var project = await _context.Project.FindAsync(id);
            if (project == null)
            {
                return NotFound();
            }
            var sectionListSelected = project.ProjectSections.Select(x => x.SectionId).ToList();
            var siteListSelected = project.ProjectSites.Select(x => x.SiteId).ToList();
            LoadViewData(project, sectionListSelected, siteListSelected);

            return View(project);
        }

        // POST: Projects/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int id, [Bind("ID,TypeProjectID,Name,SiteIds,Year,SectionIds")] Project project)
        {
            if (id != project.ID)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    if (project.SectionIds == null)
                    {
                        ModelState.AddModelError("ProjectSections", "The Sections is required");
                        LoadViewData(project, project.SectionIds, project.SiteIds);
                        return View();
                    }
                    if (project.SiteIds == null)
                    {
                        ModelState.AddModelError("ProjectSites", "The Sites is required");
                        LoadViewData(project, project.SectionIds, project.SiteIds);
                        return View();
                    }

                    var addedSectionList = await ManageProjectSection(project.ID, project.SectionIds);
                    var addedSiteList = await ManageProjectSite(project.ID, project.SiteIds);
                    project.ProjectSections = addedSectionList.Select(x => new ProjectSection { SectionId = x }).ToList();
                    project.ProjectSites = addedSiteList.Select(x => new ProjectSite { SiteId = x }).ToList();

                    _context.Update(project);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!ProjectExists(project.ID))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            LoadViewData(project, project.SectionIds, project.SiteIds);

            return View(project);
        }

        private async Task<List<int>> ManageProjectSection(int projectId, ICollection<int> sectionIds)
        {
            var projectSections = await _context.ProjectSection.Where(x => x.ProjectId == projectId).ToListAsync();
            var removeList = new List<ProjectSection>();
            var addedList = new List<int>();

            if (sectionIds != null)
            {
                removeList = projectSections.Where(x => !sectionIds.Contains(x.SectionId)).ToList();
                addedList = sectionIds.Where(x => !projectSections.Select(x => x.SectionId).Contains(x)).ToList();
            }
            else
            {
                removeList = projectSections;
            }
            _context.ProjectSection.RemoveRange(removeList);

            await _context.SaveChangesAsync();

            return addedList;
        }

        private async Task<List<int>> ManageProjectSite(int projectId, ICollection<int> siteIds)
        {
            var projectSites = await _context.ProjectSite.Where(x => x.ProjectId == projectId).ToListAsync();
            var removeList = new List<ProjectSite>();
            var addedList = new List<int>();

            if (siteIds != null)
            {
                removeList = projectSites.Where(x => !siteIds.Contains(x.SiteId)).ToList();
                addedList = siteIds.Where(x => !projectSites.Select(x => x.SiteId).Contains(x)).ToList();
            }
            else
            {
                removeList = projectSites;
            }
            _context.ProjectSite.RemoveRange(removeList);

            await _context.SaveChangesAsync();

            return addedList;
        }

        // GET: Projects/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var project = await _context.Project
                .Include(p => p.TypeProject)
                .Include(p => p.ProjectSections)
                .FirstOrDefaultAsync(m => m.ID == id);
            if (project == null)
            {
                return NotFound();
            }

            return View(project);
        }

        // GET: Projects/Delete/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var project = await _context.Project
                .Include(p => p.TypeProject)
                .FirstOrDefaultAsync(m => m.ID == id);
            if (project == null)
            {
                return NotFound();
            }

            return View(project);
        }

        // POST: Projects/Delete/5
        [Authorize(Roles = "Admin")]
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var project = await _context.Project.FindAsync(id);
            _context.Project.Remove(project);
            await _context.SaveChangesAsync();

            return RedirectToAction(nameof(Index));
        }

        private void LoadViewData(Project project, ICollection<int> sectionListSelected, ICollection<int> siteListSelected)
        {
            ViewData["TypeProjectID"] = new SelectList(_context.TypeProject.Where(x => x.Active), "ID", "Name", project?.TypeProjectID);
            ViewData["Sections"] = new MultiSelectList(_context.Section.Where(x => x.Active), "ID", "Name", sectionListSelected);

TestJose/Views/CommentProjects/Create.cshtml
@model TestJose.DataAccess.CommentProject

@{
    ViewData["Title"] = "Create comment";
}

<h4>Create Comment</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="ProjectID" />
            <div class="form-group">
                <label asp-for="SectionID" class="control-label"></label>
                <select asp-for="SectionID" class="form-control" asp-items="ViewBag.SectionID"></select>
                <span asp-validation-for="SectionID" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Date" class="control-label"></label>
                <input asp-for="Date"  class="form-control" type="date" asp-format="{0:yyyy-MM-dd}" value="@DateTime.Today.ToString("yyyy-MM-dd")"/>
                <span asp-validation-for="Date" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Comment" class="control-label"></label>
                <textarea rows="4" asp-for="Comment" class="form-control"></textarea>
                <span asp-validation-for="Comment" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-route-projectId="@ViewData["ProjectID"]" asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

TestJose/Views/CommentProjects/Delete.cshtml
@model TestJose.DataAccess.CommentProject

@{
    ViewData["Title"] = "Delete";
}

<h4>Delete Comment</h4>

<h6>Are you sure you want to delete this?</h6>
<div>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Project)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Project.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.User)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.User.UserName)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.SectionID)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Section.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Date)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Date)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Comment)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Comment)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="ID" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-route-projectId="@Model.ProjectID" asp-action="Index">Back to List</a>
    </form>
</div>

TestJose/Views/CommentProjects/Details.cshtml
@model TestJose.DataAccess.CommentProject

@{
    ViewData["Title"] = "Details Comment";
}

<div>
    <h4>Details Comment</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.ProjectID)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Project.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.SectionID)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Section.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.UserID)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.User.UserName)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Date)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Date)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Comment)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Comment)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.ID">Edit</a> |
    <a asp-route-projectId="@Model.ProjectID" asp-action="Index">Back to List</a>
</div>

TestJose/Views/CommentProjects/Edit.cshtml
@model TestJose.DataAccess.CommentProject

@{
    ViewData["Title"] = "Edit Comment";
}

<h4>Edit Comment</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="ID" />
            <input type="hidden" asp-for="ProjectID" />
            <input type="hidden" asp-for="UserID" />
            <div class="form-group">
                <label asp-for="SectionID" class="control-label"></label>
                <select asp-for="SectionID" class="form-control" asp-items="ViewBag.SectionID"></select>
                <span asp-validation-for="SectionID" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Date" class="control-label"></label>
                <input asp-for="Date" class="form-control" type="date" asp-format="{0:yyyy-MM-dd}"/>
                <span asp-validation-for="Date" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Comment" class="control-label"></label>
                <textarea rows="4" asp-for="Comment" class="form-control"></textarea>
                <span asp-validation-for="Comment" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-route-projectId="@Model.ProjectID" asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

TestJose/Views/CommentProjects/Index.cshtml
@using X.PagedList.Mvc.Core;
@using TestJose.DataAccess;
@using X.PagedList.Web.Common;

@model X.PagedList.IPagedList<CommentProject>

@{
    ViewData["Title"] = "Comments to project";

}

<h4>Comments to project</h4>

<p>
    <a asp-route-projectId="@ViewData["ProjectID"]" asp-action="Create">New Comment</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayName("Date")
            </th>
            <th>
                @Html.DisplayName("Section")
            </th>
            <th>
                @Html.DisplayName("User")
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Date)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Section.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.User.UserName)
                </td>
                <td>
                    <a asp-action="Edit" asp-route-id="@item.ID">Edit</a> |
                    <a asp-action="Delete" asp-route-id="@item.ID">Delete</a> |
                    <a asp-action="Details" asp-route-id="@item.ID">Details</a>
                </td>
            </tr>
        }
    </tbody>
</table>
@*<a asp-controller="Projects" asp-action="Index">Back to Project List</a>*@

@Html.PagedListPager(Model, page => Url.Action("Index", new { page, projectId = ViewData["ProjectID"] }),
        new PagedListRenderOptionsBase
        {
            PageClasses = new string[] { "page-link" },
            UlElementClasses = new string[] { "pagination" },
            LiElementClasses = new string[] { "page-item" },
            DisplayItemSliceAndTotal = true,
            DisplayEllipsesWhenNotShowingAllPageNumbers = true,
            Display = PagedListDisplayMode.IfNeeded,
            DisplayLinkToFirstPage = PagedListDisplayMode.IfNeeded,
            DisplayLinkToLastPage = PagedListDisplayMode.IfNeeded
        }
    )

TestJose/Views/CommentProjects/MyComments.cshtml
@using X.PagedList.Mvc.Core;
@using TestJose.DataAccess;
@using X.PagedList.Web.Common;

@model X.PagedList.IPagedList<CommentProject>

@{
    ViewData["Title"] = "Comments by user";

}

<h4>All Comments by User</h4>

<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayName("Date")
            </th>
            <th>
                @Html.DisplayName("SectionID")
            </th>
            <th>
                @Html.DisplayName("Comment")
            </th>
            <th>
                @Html.DisplayName("ProjectID")
            </th>
            @*<th></th>*@
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Date)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Section.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Comment)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Project.Name)
                </td>
                @*<td>
                        <a asp-action="Edit" asp-route-id="@item.ID">Edit</a>
                    </td>*@
            </tr>
        }
    </tbody>
</table>

@Html.PagedListPager(Model, page => Url.Action("MyComments", new { page }),
        new PagedListRenderOptionsBase
        {
            PageClasses = new string[] { "page-link" },
            UlElementClasses = new string[] { "pagination" },
            LiElementClasses = new string[] { "page-item" },
            DisplayItemSliceAndTotal = true,
            DisplayEllipsesWhenNotShowingAllPageNumbers = true,
            Display = PagedListDisplayMode.IfNeeded,
            DisplayLinkToFirstPage = PagedListDisplayMode.IfNeeded,
            DisplayLinkToLastPage = PagedListDisplayMode.IfNeeded
        }
    )